#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Silver
#property indicator_color2  Silver
#property indicator_color3  Silver
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_color4  DeepSkyBlue
#property indicator_color5  Red
#property indicator_color6  Red

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern int    SF                  = 5;
extern int    RsiPeriod           = 14;
extern int    RsiPrice            = 0;
extern double WP                  = 4.236;

extern bool   arrowsVisible       = false;
extern string arrowsIdentifier    = "QqeArrows1";
extern double arrowsDisplacement  = 1.0;
extern color  arrowsUpColor       = Aqua;
extern color  arrowsDnColor       = Yellow;
extern int    arrowsUpCode        = 233;
extern int    arrowsDnCode        = 234;
extern int    arrowsUpSize        = 1;
extern int    arrowsDnSize        = 1;

extern bool   alertsOn            = false;
extern bool   alertsOnSlope       = true;
extern bool   alertsOnSignalCross = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;


//
//
//
//
//

double TrendU[];
double TrendDa[];
double TrendDb[];
double RsiMa[];
double RsiMaDa[];
double RsiMaDb[];
double slope[];
double trend[];
double emas[][3];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,RsiMa);    SetIndexLabel(0, "QQE");
   SetIndexBuffer(1,RsiMaDa);  SetIndexLabel(1, "QQE down");
   SetIndexBuffer(2,RsiMaDb);  SetIndexLabel(2, "QQE down");
   SetIndexBuffer(3,TrendU);   SetIndexLabel(1, "QQE trend up");
   SetIndexBuffer(4,TrendDa);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(5,TrendDb);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(6,slope); 
   SetIndexBuffer(7,trend); 
   
       //
       //
       //
       //
       //
      
          indicatorFileName = WindowExpertName();
          calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
          returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
          timeFrame         = stringToTimeFrame(TimeFrame);
      
       //
       //
       //
       //
       // 
       
   IndicatorShortName(timeFrameToString(timeFrame)+"  QQE ("+SF+","+RsiPeriod+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iEma 0
#define iEmm 1
#define iQqe 2

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { RsiMa[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     if (ArrayRange(emas,0) != Bars) { ArrayResize(emas,Bars);  }
     if (!calculateValue && slope[limit]==-1) CleanPoint(limit,RsiMaDa,RsiMaDb);
     if (!calculateValue && trend[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);

     double alpha1 = 2.0/(SF+1.0);
     double alpha2 = 2.0/(RsiPeriod*2.0);
      
     for (i=limit, r=Bars-i-1; i>=0; i--,r++)
     {  
        RsiMa[i]   = RsiMa[i+1] + alpha1*(iRsi(iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i),RsiPeriod,i) - RsiMa[i+1]);
        emas[r][iEma] = emas[r-1][iEma] + alpha2*(MathAbs(RsiMa[i+1]-RsiMa[i]) - emas[r-1][iEma]);
        emas[r][iEmm] = emas[r-1][iEmm] + alpha2*(emas[r][iEma] - emas[r-1][iEmm]);

        //
        //
        //
        //
        //

           double rsi0 = RsiMa[i];
           double rsi1 = RsiMa[i+1];
           double dar  = emas[r  ][iEmm]*WP;
           double tr   = emas[r-1][iQqe];
           double dv   = tr;
   
              if (rsi0 < tr) { tr = rsi0 + dar; if ((rsi1 < dv) && (tr > dv)) tr = dv; }
              if (rsi0 > tr) { tr = rsi0 - dar; if ((rsi1 > dv) && (tr < dv)) tr = dv; }
         
        //
        //
        //
        //
        //
         
           TrendU[i]     = tr;
           emas[r][iQqe] = tr;
           TrendDa[i]    = EMPTY_VALUE;
           TrendDb[i]    = EMPTY_VALUE;
           RsiMaDa[i]    = EMPTY_VALUE;
           RsiMaDb[i]    = EMPTY_VALUE;
           slope[i]      = slope[i+1];
           trend[i]      = trend[i+1];

              if (RsiMa[i]>RsiMa[i+1]) slope[i] =  1;
              if (RsiMa[i]<RsiMa[i+1]) slope[i] = -1;
              if (tr     < RsiMa[i]  ) trend[i] =  1;
              if (tr     > RsiMa[i]  ) trend[i] = -1;

         if (slope[i] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
         if (trend[i] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
         manageArrow(i); 
   }    
   manageAlerts();    
   return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period())); 
   if (slope[limit]==-1) CleanPoint(limit,RsiMaDa,RsiMaDb);
   if (trend[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);
     for(i=limit; i>=0; i--)
     {
        int y = iBarShift(NULL,timeFrame,Time[i]);
           TrendDa[i] = EMPTY_VALUE;
           TrendDb[i] = EMPTY_VALUE;
           RsiMaDa[i] = EMPTY_VALUE;
           RsiMaDb[i] = EMPTY_VALUE;
           RsiMa[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RsiPeriod,RsiPrice,WP,arrowsVisible,arrowsIdentifier,arrowsDisplacement,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,0,y);
           TrendU[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RsiPeriod,RsiPrice,WP,arrowsVisible,arrowsIdentifier,arrowsDisplacement,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,3,y); 
           slope[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RsiPeriod,RsiPrice,WP,arrowsVisible,arrowsIdentifier,arrowsDisplacement,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,6,y);
           trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RsiPeriod,RsiPrice,WP,arrowsVisible,arrowsIdentifier,arrowsDisplacement,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,7,y); 
               
      }
      for(i=limit; i>=0; i--)
      {
         if (slope[i] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
         if (trend[i] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
      }
      manageAlerts();
return(0);
}   

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":"+Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow("",i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
         if (trend[i] ==-1) drawArrow("",i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(string add, int i,color theColor,int theCode,int theSize, bool up)
{
   string name = arrowsIdentifier+":"+add+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,   theColor);
         ObjectSet(name,OBJPROP_WIDTH,    theSize);      
         
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1, Low[i] - arrowsDisplacement * gap);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar," QQE sloping up");
            if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar," QQE sloping down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar," QQE crossed signal line up");
            if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar," QQE crossed signal line down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," QQE "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

